#!/usr/bin/perl

use File::Temp;

if ($ENV{'REQUEST_METHOD'} eq "POST") {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
} else {
#	die "not POST method.";
	$buffer = "ERROR";
}

# --- output TimeStampRequest to temp file.
my($tmp_fh, $tmp_filename) = File::Temp::tempfile();
print $tmp_fh $buffer;
close($tmp_fh);

# --- generate and get TimeStampResponse.
$command = "openssl ts -reply -sha512 -config /var/www/ca/tsa/CAtsa2.cnf -passin pass:YOUR_PSWD";
$command = $command . " -queryfile " . $tmp_filename;
$response = `$command`;

# --- output header.
print "Content-type: application/timestamp-reply\n";
print "Content-length: ". length($response) . "\n";
print "\n";

# --- output body.
print $response;

# --- delete temp file.
unlink $tmp_filename;

# --- get date time.
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;

# --- log strings.
$time = sprintf("%04d\/%02d\/%02d\-%02d\:%02d:%02d", $year, $mon, $mday, $hour, $min, $sec);
$log_filename = "/var/www/ca/tsa/log/" . sprintf("tsa-%04d\-%02d.log", $year, $mon);
$log_mesg = $time . " from " . $ENV{'REMOTE_ADDR'} . " with Demo Open\n";

# --- output to log file.
open($log_fh, ">>", $log_filename);
print $log_fh $log_mesg;
close($log_fn);

# --- end.
exit 0;

